//
//  AddBookViewController.m
//  library
//
//  Created by user on 2012-03-22.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import "AddBookViewController.h"
#import "LibAppDelegate.h"
#import "Book.h"

@implementation AddBookViewController

@synthesize bookTitle = _bookTitle;
@synthesize isbn = _isbn;
@synthesize dateTook = _dateTook;
@synthesize period = _period;

@synthesize delegate = _delegate;
@synthesize contextPtr = _contextPtr;
@synthesize reader = _reader;

- (void)viewDidLoad {
    NSDateFormatter *formater = [[NSDateFormatter alloc] init];
    formater.dateFormat = @"yyyy-MM-dd";
    
    self.dateTook.text = [formater stringFromDate:[NSDate date]];
    
    self.bookTitle.delegate = self;
    self.isbn.delegate = self;
    
    [self.bookTitle becomeFirstResponder];
}

- (void)viewDidUnload {
    [self setTitle:nil];
    [self setIsbn:nil];
    [self setDateTook:nil];
    [self setPeriod:nil];
    [self setBookTitle:nil];
    [super viewDidUnload];
}

- (IBAction)periodChanged:(UIStepper *)sender {
    self.period.text = [NSString stringWithFormat:@"%i", (int)sender.value];
}

- (IBAction)done:(id)sender {
    if (self.bookTitle.text.length && self.isbn.text.length) {
        Book *newBook = [NSEntityDescription insertNewObjectForEntityForName:@"Book" inManagedObjectContext:self.contextPtr];
        
        newBook.title = self.bookTitle.text;
        newBook.isbn = self.isbn.text;
        
        NSInteger flag = NSYearCalendarUnit | NSMonthCalendarUnit | NSDayCalendarUnit;
        NSDateComponents *dateComponents = [[NSCalendar currentCalendar] components:flag fromDate:[NSDate date]];
        dateComponents.day += [self.period.text intValue] + 1;
        
        newBook.dateGiveBack = [[NSCalendar currentCalendar] dateFromComponents:dateComponents];
        newBook.tookByReader = self.reader;
        
        [(LibAppDelegate *)[[UIApplication sharedApplication] delegate] saveContext];
        [self.delegate dismissAddBookViewControllerWithReturnValue:YES];
    }
}

- (IBAction)cancel:(id)sender {
    [self.delegate dismissAddBookViewControllerWithReturnValue:NO];
}

#pragma mark - UITextFieldDelegate methods

- (BOOL)textFieldShouldReturn:(UITextField *)textField {
    if ((textField == self.bookTitle) && !self.isbn.text.length) {
        [self.isbn becomeFirstResponder];
    } else {
        [textField resignFirstResponder];
    }
    
    return YES;
}
@end
