//
//  AddReaderViewController.m
//  library
//
//  Created by user on 2012-03-21.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import "AddReaderViewController.h"
#import "LibAppDelegate.h"
#import "Reader.h"


@implementation AddReaderViewController

@synthesize delegate = _delegate;
@synthesize contextPtr = _contextPtr;
@synthesize name;
@synthesize surname;

- (IBAction)done:(id)sender {
    if (self.name.text.length && self.surname.text.length) {
        
// Check if name and surname are unique
        NSFetchRequest *request = [NSFetchRequest fetchRequestWithEntityName:@"Reader"];
        //request.sortDescriptors = [[NSArray alloc] init];
        request.predicate = [NSPredicate predicateWithFormat:@"surname like %@ AND name like %@", self.surname.text, self.name.text];
        
        if (![self.contextPtr countForFetchRequest:request error:nil]) {

// Add unique reader record to 'Reader' table
            Reader *reader = [NSEntityDescription insertNewObjectForEntityForName:@"Reader"
                                                           inManagedObjectContext:self.contextPtr];
            reader.name = self.name.text;
            reader.surname = self.surname.text;
        
            [(LibAppDelegate *)[[UIApplication sharedApplication] delegate] saveContext];
            [self.delegate dismissAddReaderViewController];
        }
    }
}

- (IBAction)cancel:(id)sender {
    [self.delegate dismissAddReaderViewController];
}

- (void)viewDidLoad {
    self.name.delegate = self;
    self.surname.delegate = self;
    
    [self.name becomeFirstResponder];
}

- (void)viewDidUnload {
    [self setName:nil];
    [self setSurname:nil];
    [super viewDidUnload];
}

#pragma mark - UITextFieldDelegate methods

- (BOOL)textFieldShouldReturn:(UITextField *)textField {
    if ((textField == self.name) && !self.surname.text.length) {
        [self.surname becomeFirstResponder];
    } else {
        [textField resignFirstResponder];
    }
    
    return YES;
}

@end
