//
//  BookInfoViewController.m
//  library
//
//  Created by user on 2012-03-23.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import "BookInfoViewController.h"

@interface BookInfoViewController()

@property (weak, nonatomic) IBOutlet UITableView *bookInfoView;
@end

@implementation BookInfoViewController

@synthesize bookInfoView;
@synthesize book = _book;

- (void)viewDidLoad {
    bookInfoView.dataSource = self;
}

- (void)viewDidUnload {
    [self setBookInfoView:nil];
    [super viewDidUnload];
}

#pragma mark - UITableViewDataSource methods

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView {
    return 1;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
    return 2;
}

- (NSString *)tableView:(UITableView *)tableView titleForHeaderInSection:(NSInteger)section {
    return @"Book info";
}


- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
    UITableViewCell *cell;
    
    if (indexPath.row == 0) {
        cell = [tableView dequeueReusableCellWithIdentifier:@"titleID"];
        
        cell.textLabel.text = self.book.title;
        cell.detailTextLabel.text = [@"isbn: " stringByAppendingString:self.book.isbn];
    } else {
        cell = [tableView dequeueReusableCellWithIdentifier:@"daysLeftID"];
        
        int daysLeft = (int)[self.book.dateGiveBack timeIntervalSinceNow] / 86400;
        
        if (daysLeft >= 0) {
            cell.textLabel.text = @"Days left";
            cell.detailTextLabel.text = [NSString stringWithFormat:@"%i", daysLeft];
            
            cell.detailTextLabel.textColor = [UIColor blackColor];
        } else {
            cell.textLabel.text = @"Days late";
            cell.detailTextLabel.text = [NSString stringWithFormat:@"%i", -daysLeft];
            
            cell.detailTextLabel.textColor = [UIColor redColor];
        }
    }
    
    return cell;
}
@end
