//
//  BookViewController.m
//  library
//
//  Created by user on 2012-03-22.
//  Copyright (c) 2012 __MyCompanyName__. All rights reserved.
//

#import "BookViewController.h"
#import "LibAppDelegate.h"
#import "BookInfoViewController.h"
#import "Book.h"

@interface BookViewController()

@property (strong, nonatomic) NSArray *books;
@end

@implementation BookViewController

@synthesize contextPtr = _contextPtr;
@synthesize reader = _reader;
@synthesize books = _books;

- (void)viewDidLoad {       
    self.books = [[self.reader.books allObjects] sortedArrayUsingComparator:^(Book *obj1, Book *obj2) {
        return [obj1.title compare:obj2.title options:NSCaseInsensitiveSearch];
     }];
}

- (void)prepareForSegue:(UIStoryboardSegue *)segue sender:(id)sender {
    if ([segue.identifier isEqualToString:@"AddBookSegue"]) {
        AddBookViewController *destination = segue.destinationViewController;
        
        destination.delegate = self;
        destination.contextPtr = self.contextPtr;
        destination.reader = self.reader;
    } else {
        BookInfoViewController *destination = segue.destinationViewController;
        
        destination.book = [self.books objectAtIndex:self.tableView.indexPathForSelectedRow.row];
    }
}

- (void)dismissAddBookViewControllerWithReturnValue:(BOOL)returnValue {
    [self dismissModalViewControllerAnimated:YES];
    
    if (returnValue) {
        self.books = [self.reader.books allObjects];
        [self.tableView reloadData];
    }
}

#pragma mark - UITableViewDataSource methods

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView {
    return 1;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section {
    return [self.books count];
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath {
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:@"Book Cell"];
    
    cell.textLabel.text = [[self.books objectAtIndex:indexPath.row] title];
    
    return cell;
}

- (void)tableView:(UITableView *)tableView commitEditingStyle:(UITableViewCellEditingStyle)editingStyle forRowAtIndexPath:(NSIndexPath *)indexPath {
    if (editingStyle == UITableViewCellEditingStyleDelete) {
        [self.contextPtr deleteObject:[self.books objectAtIndex:indexPath.row]];
        [(LibAppDelegate *)[[UIApplication sharedApplication] delegate] saveContext];
        
        self.books = [self.reader.books allObjects];
        [self.tableView reloadData];
    }
}

@end
